-- testbed for the half adder

library ieee;
use ieee.std_logic_1164.all;

-- the testbed has no external connections
entity tb is
end tb;

architecture behav of tb is
  signal x,y,s,c : std_logic;           -- internal signals for us to set

begin
  -- the ?_clock processes just manipulate the signals at given times,
  -- so we can see how the circuit reacts.
  x_clock: process
  begin
    x <= '0', '1' after 50 ns;
    wait for 100 ns;
  end process;
  
  y_clock: process
  begin
    y <= '0', '1' after 100 ns;
    wait for 200 ns;
  end process;
  
  -- hook up the half-adder as the UUT (unit under test).
  UUT: entity work.half_adder(struct)
  port map (
    x => x,
    y => y,
    s => s,
    c => c);
  
end behav;
